select
   ' ' as "Regio Gerar"
  ,' ' as "Ano Gerar"
  ,' ' as "Tcnico"
  , faz.nome as "Nome da fazenda"
  , mun.uf as "Estado"
  , 'TE' as "Tcnica"
  , an.numero as "Receptora"
  , (select first 1 re.valor from medida re where re.cdanimal = ia.cdanimal and re.cdtipomedida = 2 and re.dtmedida >= (ia.data - 20)
        and re.dtmedida <= (ia.data + 20) order by re.dtmedida desc) as "Escore"
  , (select grausangue from sp_calculagrausangue(ia.cdanimal)) as "Raa"
  , ((select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) as "Nmero de partos"
  , ultpar.data as "Data parto"
  , (case ultpar.retencaoplacenta when 1 then 'Sim' when 0 then 'Nao' else null end) as "Reteno de placenta"
  , (case when
        ((exists (select * from mamite re where re.cdanimal = ia.cdanimal and re.data >= (ia.data - 30) and re.data <= (ia.data + 30)
                    and ((re.ad in (0,1,2)) or (re.ae in (0,1,2)) or (re.pd in (0,1,2)) or (re.pe in (0,1,2))))) or
        (exists (select * from doencaanimal re where re.cdanimal = ia.cdanimal and re.dtinicio > ultpar.data and re.dtinicio <= ia.data)))
          then 'Sim' else null end) as "Doena na lactao"
  , ia.data as "Data TE"
  , (select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.data > coalesce(ultpar.data, '1900-01-01')
        and re.cdtiporeproducao in (1,2,3)) as "N cob"
  , (case when (iaant.cdreproducao is not null) then (ia.data - iaant.data) else null end) as "Intervalo entre tentativas"
  , (case when (ia.condicaoia <> 'I') then 'Cio' else 'IATF' end) as "TETF ou Cio"
  , (case when (upper(prot.descricao) like '%TIPO%A%') then 'Tipo A'
            when (upper(prot.descricao) like '%TIPO%B%') then 'Tipo B'
            when (upper(prot.descricao) like '%TIPO%C%') then 'Tipo C'
            else null end) as "Tipo Protocolo"
  ,' ' as "Implante"
  , (case when
            ((select count(*) from principioativo re join protocoloiatfprincipioativo ppre on ppre.cdprincipioativo = re.cdprincipioativo
                            where upper(re.nome) like 'GONADOTRO%' and ppre.dia = 0 and ppre.cdprotocoloiatf = ia.cdprotocoloiatf) > 0)
        then 'Sim' else null end) as "gNrh incio do protocolo"
  ,' ' as "PGF"
  , protpa.uso as "N uso do Cidr"
  , (case when
		(exists (select * from reproducao re where re.cdanimal = ia.cdanimal and
					((re.cdresultadoexameoe in (select cdresultadoexameginecologico from resultadoexameginecologico where ((upper(nomeresumido) like '%CL%') or (upper(nomeresumido) like '%LTEO%'))))
							or (re.cdresultadoexameod in (select cdresultadoexameginecologico from resultadoexameginecologico where ((upper(nomeresumido) like '%CL%') or (upper(nomeresumido) like '%LTEO%'))))) and re.data >= (ia.data - 19) and re.data <= (ia.data - 16)))
			then '1' else null end) as "CL inicio protocolo"
  , (case ia.cio when 1 then 'Sim' when 2 then 'No' when 0 then 'Nao' else null end) as "Deu cio para TE"
  , ia.temperaturaretal as "T.retal"
  , ia.hora as "Horrio TE"
  , coalesce(rep.regnumsemen, rep.nome, rep.numero) as "Touro"
  , (case rep.cdtiposemen when 1 then 'Convencional' when 2 then 'Sexado' when 3 then 'Sexado' else null end) as "Sexado"
  ,' ' as "Central"
  , pes.nome as "Tcnico transferncia"
  , coalesce((select first 1 re.pesototal from leite re where re.cdanimal = ia.cdanimal and re.dtleite >= (ia.data - 30) and re.dtleite <= ia.data
        order by re.dtleite desc),
    (select first 1 re.pesototal from leite re where re.cdanimal = ia.cdanimal and re.dtleite <= (ia.data + 30) and re.dtleite >= ia.data
        order by re.dtleite desc)) as "Leite"
  , coalesce((select first 1 re.ccs from analiseleite re where re.cdanimal = ia.cdanimal and re.dtanaliseleite >= (ia.data - 30) and re.dtanaliseleite <= ia.data
        order by re.dtanaliseleite desc),
    (select first 1 re.ccs from analiseleite re where re.cdanimal = ia.cdanimal and re.dtanaliseleite <= (ia.data + 30) and re.dtanaliseleite >= ia.data
        order by re.dtanaliseleite desc)) as "CCS"
  , (case when (exists (select * from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and re.data <= (ia.data + 30)
                            and re.cdtiporeproducao in (1,2,3))) then 'N'
          when ((cat30.cdcategoria = 1) and (prox.diagnostico = 'P')) then 'P'
          when (cat30.cdcategoria = 3) then 'P'
          when (cat30.cdcategoria = 4) then 'N'
          when ((cat30.cdcategoria = 1) and ((prox.diagnostico is null) or (prox.diagnostico <> 'P'))) then 'N'
          else null end) as "Prenhez 30 dias"
  , (case when (exists (select * from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and re.data <= (ia.data + 60)
                            and re.cdtiporeproducao in (1,2,3))) then 'N'
          when ((cat60.cdcategoria = 1) and (prox.diagnostico = 'P')) then 'P'
          when (cat60.cdcategoria = 3) then 'P'
          when (cat60.cdcategoria = 4) then 'N'
          when ((cat60.cdcategoria = 1) and ((prox.diagnostico is null) or (prox.diagnostico <> 'P'))) then 'N'
          else null end) as "Prenhez 60 dias"
  , (case when
            ((select count(*) from aplicacaoproduto re join produto pre on pre.cdproduto = re.cdproduto where re.cdanimal = ia.cdanimal and
                    re.dtaplicacaoproduto < ia.data and re.dtaplicacaoproduto >= (ia.data - (12*30.5)) and
                    upper(pre.nome) like '%CATTLE%MASTER%') > 0)
        then 'Sim' else null end) as  "Vacina Cattle Master"
  ,(select valor from configuracao conf where conf.nome like '%PeriodoReproducaoPosParto%') as PVE
  ,' ' as "Durao do protocolo"
  ,' ' as "Controle de PI"
  , coalesce(ia.horaaux, ia.hora) as "EXTRA - Horrio do cio"
  , prottotal.descricao as "EXTRA - Nome do Protocolo"
  , ia.observacao as "EXTRA - Observao TE"
  , rep.nome as "EXTRA - Nome Touro"
  , rep.numero as "EXTRA - Nmero Touro"
  , faz.idweb as "EXTRA - Cdigo Web fazenda"
  , doa.numero as "EXTRA - Nmero doadora"
  , (case ia.cio when 1 then 'Sim' when 2 then 'Irregula' when 0 then 'Nao' else null end) as "EXTRA - Detalhe do cio"
from
  fazenda faz
  join animal an on 1 = 1
  join reproducao ia on ia.cdanimal = an.cdanimal
  join animal emb on emb.cdanimal = ia.cdembriao
  join animal doa on doa.cdanimal = emb.cdmae
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao = 7 and re.data < ia.data
        order by re.data desc)
  left join reproducao iaant on iaant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data >
    coalesce(ultpar.data, '1900-01-01') and re.data < ia.data order by re.data desc)
  left join protocoloiatf prot on prot.cdprotocoloiatf = ia.cdprotocoloiatf and
    ((upper(prot.descricao) like '%TIPO%A%') or (upper(prot.descricao) like '%TIPO%B%') or (upper(prot.descricao) like '%TIPO%C%'))
  left join protocoloiatf prottotal on prottotal.cdprotocoloiatf = ia.cdprotocoloiatf
  left join protocoloiatfprincipioativo protpa on protpa.cdprotocoloiatfprincipioativo =
    (select first 1 re.cdprotocoloiatfprincipioativo from protocoloiatfprincipioativo re join principioativo repa on repa.cdprincipioativo
        = re.cdprincipioativo and upper(repa.nome) = 'PROGESTERONA' where re.cdprotocoloiatf = prot.cdprotocoloiatf order by re.uso asc)
  left join animal rep on rep.cdanimal = emb.cdpai
  left join pessoa pes on pes.cdpessoa = ia.cdpessoa
  join categoria cat30 on cat30.cdcategoria =
    (select creprodutiva from sp_categoriaanimal((ia.data + 30), 'cdanimal = ' || ia.cdanimal))
  join categoria cat60 on cat60.cdcategoria =
    (select creprodutiva from sp_categoriaanimal((ia.data + 60), 'cdanimal = ' || ia.cdanimal))
  left join reproducao prox on prox.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and
        ((re.cio in (1,2)) or (re.diagnostico is not null) or (re.cdtiporeproducao in (1,2,3,7))) order by re.data asc)
  left join municipio mun on faz.cdmunicipio = mun.cdmunicipio
where
  ia.cdtiporeproducao = 3
  and ia.cdprotocoloiatf is not null
order by
  an.numordenado